# This file was auto-generated by Fern from our API Definition.

from backports.cached_property import cached_property

from .environment import IntegralApiEnvironment
from .resources.api_keys.client import ApiKeysClient
from .resources.application_user.client import ApplicationUserClient
from .resources.logs.client import LogsClient
from .resources.parse.client import ParseClient
from .resources.tiers.client import TiersClient


class IntegralApi:
    def __init__(self, *, environment: IntegralApiEnvironment, integral_application_id: str, api_key: str):
        self._environment = environment
        self.integral_application_id = integral_application_id
        self.api_key = api_key

    @cached_property
    def api_keys(self) -> ApiKeysClient:
        return ApiKeysClient(
            environment=self._environment, integral_application_id=self.integral_application_id, api_key=self.api_key
        )

    @cached_property
    def application_user(self) -> ApplicationUserClient:
        return ApplicationUserClient(
            environment=self._environment, integral_application_id=self.integral_application_id, api_key=self.api_key
        )

    @cached_property
    def logs(self) -> LogsClient:
        return LogsClient(
            environment=self._environment, integral_application_id=self.integral_application_id, api_key=self.api_key
        )

    @cached_property
    def parse(self) -> ParseClient:
        return ParseClient(
            environment=self._environment, integral_application_id=self.integral_application_id, api_key=self.api_key
        )

    @cached_property
    def tiers(self) -> TiersClient:
        return TiersClient(
            environment=self._environment, integral_application_id=self.integral_application_id, api_key=self.api_key
        )
